﻿Imports System.Drawing
Module Module1
    Private JrStegano1 As JRSteganoF2.JRStegano

    Sub Main()
        JrStegano1 = New JRSteganoF2.JRStegano


        'in this demo the user must get a own serial number from jrsoft. The developer need only a user license too.
        JrStegano1.SerialNumber = 0
        JrStegano1.RegCode = 0

        JrStegano1.UseCryptService = False
        JrStegano1.UserPassword = ""

        'copy files to ...
        'copy files who are stored in a picture to this path
        '        txt_copytopath.Text = System.AppDomain.CurrentDomain.BaseDirectory()


        'load a picture with data
        Console.WriteLine("Load stegano picture from file")
        'JrStegano1.Image = New Bitmap(System.IO.Path.Combine(System.AppDomain.CurrentDomain.BaseDirectory(), "Picture_With_Datas.png"))
        JrStegano1.LoadPictureFromFile(System.IO.Path.Combine(System.AppDomain.CurrentDomain.BaseDirectory(), "Picture_With_Datas.png"))



        'read the data inside the stegano picture and list in the listbox
        Console.WriteLine("Read the Datas inside the picture")
        Readdatas(0, False)


        Console.WriteLine("search for sample user data object with key usr2 in the stegano picture")
        ReadTestUserlist("usr2")


        Console.WriteLine("add string datas to the stegano picture")
        addtext("This is new text", True)


        Console.WriteLine("add more userlist objects ")
        addobject()


        Console.WriteLine("save the manipulated picture as Picture_With_Datas_new.png")
        JrStegano1.SaveAsPNG(System.IO.Path.Combine(System.AppDomain.CurrentDomain.BaseDirectory(), "Picture_With_Datas_new.png"), True)

        Console.WriteLine("format the picture, all Data will be lost ")
        JrStegano1.ClearAllData()


        'read the data inside the stegano picture and list in the listbox
        Console.WriteLine("Read the Datas inside the picture")
        Readdatas(0, False)


        'load a picture with data
        Console.WriteLine("Load the manipulated picture Picture_With_Datas_new.png back")
        'JrStegano1.Image = New Bitmap(System.IO.Path.Combine(System.AppDomain.CurrentDomain.BaseDirectory(), "Picture_With_Datas_new.png"))
        JrStegano1.LoadPictureFromFile(System.IO.Path.Combine(System.AppDomain.CurrentDomain.BaseDirectory(), "Picture_With_Datas_new.png"))



        Console.WriteLine("search for new created sample user data object with key^^ usr12 in the stegano picture")
        ReadTestUserlist("usr12")


        'Show use of individual Crypt service
        Console.WriteLine("format the picture, all Data will be lost ")
        JrStegano1.ClearAllData()

        JrStegano1.UseCryptService = True
        JrStegano1.UserPassword = "thisismypassword"

        Console.WriteLine("add userlist objects crypted ")
        addobject()

        Console.WriteLine("search with wrong password ")
        JrStegano1.UserPassword = "thisismypasswort"
        ReadTestUserlist("usr12")

        Console.WriteLine("search with right password ")
        JrStegano1.UserPassword = "thisismypassword"
        ReadTestUserlist("usr12")


        Console.WriteLine("add some string crypted")
        addtext("This is new cryptet text1", True)
        addtext("This is new cryptet text2", True)
        addtext("This is new cryptet text3", True)
        addtext("This is new cryptet text4", True)



        Console.WriteLine("only for example, we add Picture_With_Datas_new.png to this stegano picture!")
        If Not JrStegano1.AddFileEx(System.IO.Path.Combine(System.AppDomain.CurrentDomain.BaseDirectory(), "Picture_With_Datas_new.png"), True) Then
            Console.WriteLine("Can't add picture")
        End If

        Console.WriteLine("We kill Picture_With_Datas_new.png! in the directory")
        System.IO.File.Delete(System.IO.Path.Combine(System.AppDomain.CurrentDomain.BaseDirectory(), "Picture_With_Datas_new.png"))



        'read the data inside the stegano picture and list in the listbox
        Console.WriteLine("We Read the Datas inside the picture and let copy files inside, so we get Picture_With_Datas_new.png back")
        Readdatas(0, True)


        'We open now the extracted Picture_With_Datas_new.png again
        Console.WriteLine("We Read the Datas from the eytracted Picture_With_Datas_new.png again to show datas are ok")
        JrStegano1.UseCryptService = False
        'JrStegano1.Image = New Bitmap(System.IO.Path.Combine(System.AppDomain.CurrentDomain.BaseDirectory(), "Picture_With_Datas_new.png"))
        JrStegano1.LoadPictureFromFile(System.IO.Path.Combine(System.AppDomain.CurrentDomain.BaseDirectory(), "Picture_With_Datas_new.png"))


        'read the data inside the stegano picture and list in the listbox
        Console.WriteLine("We Read the Datas inside the extracted picture ")
        Readdatas(0, False)


        Console.WriteLine("search in the extracted picture for new created sample user data object with key usr12 in the stegano picture")
        ReadTestUserlist("usr12")

        Console.WriteLine("yes! stegano is safe and can be easy")



    End Sub

    Private Sub ReadTestUserlist(searchkey As String)

        'Build the sample userlist class 
        Dim xusers As examplemyusers.testclass.users = New examplemyusers.testclass.users
        xusers.myusers = New Generic.List(Of examplemyusers.testclass.user)

        Dim listmax As Integer = 5


        Dim myfileInfos As System.Collections.Generic.List(Of JRSteganoF2.ScanInfo)
        'Example we get only byte datas from the stegano picture    
        xusers = JrStegano1.ScanPicture_GetObject(searchkey)

        If Not IsNothing(xusers) Then
            Console.WriteLine("Found Userlist")

            For Each myuser As examplemyusers.testclass.user In xusers.myusers
                Console.WriteLine(myuser.name)
                listmax = listmax - 1
                If listmax = 0 Then
                    Exit For
                End If
            Next
        Else
            Console.WriteLine("not found")
        End If
    End Sub


    Private Sub Readdatas(method As Integer, copyfiles As Boolean)

        Dim FileCopyTo As String = ""

        If copyfiles = True Then
            FileCopyTo = System.AppDomain.CurrentDomain.BaseDirectory()
        End If

        Dim OverwriteFiles As Boolean = False
        '    
        Dim myfileInfos As System.Collections.Generic.List(Of JRSteganoF2.ScanInfo)

        Select Case method
            Case 0
                'Example we get all data types from the stegano picture    
                myfileInfos = JrStegano1.ScanPicture_GetAll(FileCopyTo, OverwriteFiles)
            Case 1
                'Example we get only string datas from the stegano picture    
                myfileInfos = JrStegano1.ScanPicture_GetStrings()
            Case 2
                'Example we get only filenames and files from the stegano picture    
                myfileInfos = JrStegano1.ScanPicture_GetFiles(FileCopyTo, OverwriteFiles)
            Case 3
                'Example we get only filenames and filesize from the stegano picture    
                myfileInfos = JrStegano1.ScanPicture_GetFiles("", False)
            Case 4
                'Example we get only byte datas from the stegano picture    
                myfileInfos = JrStegano1.ScanPicture_GetByteDatas()
        End Select

        For Each myinfo As JRSteganoF2.ScanInfo In myfileInfos
            Select Case myinfo.Type
                Case JRSteganoF2.JRStegano.Scanreq.TextDatas
                    Console.WriteLine(myinfo.Value)
                Case JRSteganoF2.JRStegano.Scanreq.Filename
                    Console.WriteLine("Filename " + myinfo.Value + " Filesize" + myinfo.Size.ToString)
                Case JRSteganoF2.JRStegano.Scanreq.FileDatas
                    Console.WriteLine(myinfo.Size.ToString + " Bytes of File" + myinfo.Value)
                Case JRSteganoF2.JRStegano.Scanreq.ByteDatas
                    Console.WriteLine(myinfo.Size.ToString + " Bytes of Bytearray with Key=" + myinfo.Key)
            End Select
        Next

        'Be sure to set the eof behind last entry to add more datas to the picture
        JrStegano1.SetEOF()

    End Sub


    Private Sub addtext(Newtext As String, autoresize As Boolean)
        If Not JrStegano1.AddTextEx(Newtext, autoresize) Then
            Console.WriteLine("Can't add string")
        End If
    End Sub

    Private Sub addobject()

        'Clear old datas if needed or load blank image from file
        'JrStegano1.ClearAllData()

        'Store any serializable class in the stegano picture
        'we store the same class with diferent datas the same time
        For x As Long = 1 To 3
            'Build the example test class we build a dll so we can serialize/deserialize from each project to each we want  
            Dim xusers As examplemyusers.testclass.users = New examplemyusers.testclass.users
            xusers.myusers = New Generic.List(Of examplemyusers.testclass.user)

            'set example datas
            Dim user As examplemyusers.testclass.user
            For n As Integer = 1 To 100
                user = New examplemyusers.testclass.user
                user.name = "NewUser_" + n.ToString + "_" + x.ToString
                user.password = "123456" + n.ToString
                xusers.myusers.Add(user)
            Next n

            'add the values to the stegano picture with a identifier key of max 5 chars
            Dim fixedlengthkey As String = "usr1" + x.ToString
            fixedlengthkey = fixedlengthkey.PadLeft(5, " ").Substring(0, 5)

            If Not JrStegano1.AddObjectEx(xusers, fixedlengthkey, True) Then
                Console.WriteLine("Datas not added")
            End If
        Next x


    End Sub




End Module
